#include <bits/stdc++.h>

using namespace std;

int matrica[1000][1000];

void boja(int i, int j, int brboja){
    if(matrica[i - 1][j] == -2) {
        matrica[i - 1][j] = brboja;
        boja(i - 1, j, brboja);
    }
    if(matrica[i + 1][j] == -2) {
        matrica[i + 1][j] = brboja;
        boja(i + 1, j, brboja);
    }
    if(matrica[i][j - 1] == -2) {
        matrica[i][j - 1] = brboja;
        boja(i, j - 1, brboja);
    }
    if(matrica[i][j + 1] == -2) {
        matrica[i][j + 1] = brboja;
        boja(i, j + 1, brboja);
    }
    return;

}

int main()
{
    long long m, n, k, c1, c2;
    int brboja = 0;
    cin >> m >> n >> k;
    for(int i = 0 ; i < k ; i++){
        cin >> c1 >> c2;
        matrica[c1 - 1][c2 - 1] = -1;
    }
    for(int i = 0 ; i < m ; i++){
        for(int j = 0 ; j < n ; j++){
            if(matrica[i][j] != -1) matrica[i][j] = -2;
        }
    }
    for(int i = 0 ; i < m ; i++){
        for(int j = 0 ; j < n ; j++){
            if(matrica[i][j] == -2) brboja++, matrica[i][j] = brboja, boja(i, j, brboja);
        }
    }
    cout << brboja;
    return 0;
}